#include <ESP8266WiFi.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 20, 4);
const int sensorPin = D5;
const int resetbutton = D4;
const int buzzer = D6;
int counter = 0;
int harga = 0;
bool enableCounting = false;
bool pushreset = false;

const char* ssid = "wireless@umsida.ac.id";                      // Nama Wi-Fi      
const char* pass = "AhmadDahlan1868";    // Password Wi-Fi

const char* server = "api.pushingbox.com";

WiFiClient client;

void setup() {
  Serial.begin(115200);
  pinMode(sensorPin, INPUT);
  pinMode(resetbutton, INPUT);
  pinMode(buzzer, OUTPUT);
  WiFi.mode(WIFI_OFF);                                    // Prevents reconnection issue (taking too long to connect)
  delay(1000);
  WiFi.mode(WIFI_STA);                                    // This line hides the viewing of ESP as wifi hotspot

  WiFi.begin(ssid, pass);                             // Connect to your WiFi router
  Serial.println("");

  Serial.print("Connecting");
  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(1000);
  }
  //If connection successful show IP address in serial monitor
  Serial.println("");
  Serial.println("Successfully Connecting");
  Serial.println("Connected to Network/SSID");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());                           //IP address assigned to your ESP
  lcd.begin();
  lcd.backlight();
  lcd.setCursor(0, 0);
  lcd.print("Jumlah:0");
  lcd.setCursor(0, 1);
  lcd.print("Harga :0");
  delay(500);
}

void loop() {
  int sensorValue = digitalRead(sensorPin);
  int resetValue = digitalRead(resetbutton);
  if (sensorValue == LOW && enableCounting == false) {
    counter++;
    harga = counter * 700;
    digitalWrite(buzzer, HIGH);
    delay(100);
    digitalWrite(buzzer, LOW);
    lcd.setCursor(0, 0);
    lcd.print("Jumlah:");
    lcd.print(counter);
    lcd.setCursor(0, 1);
    lcd.print("Harga :");
    lcd.print(harga);
    enableCounting = true;
  }
  if (sensorValue == HIGH && enableCounting == true) {
    enableCounting = false;
  }
  if (resetValue == LOW && pushreset == false) {
    lcd.clear();
    lcd.setCursor(7, 0);
    lcd.print("Total");
    lcd.setCursor(6, 1);
    lcd.print(counter);
    lcd.print(" Lembar");
    lcd.setCursor(4, 2);
    lcd.print(harga);
    lcd.print(" Rupiah");
    lcd.setCursor(3, 3);
    lcd.print("Data Published");
    digitalWrite(buzzer, HIGH);
    if (client.connect(server, 80)) {
      client.print("GET /pushingbox?devid=v85ACA670EC474ED");
      client.print("&counter=");
      client.print(String(counter));
      client.print("&harga=");
      client.print(String(harga));
      client.println(" HTTP/1.1");
      client.println("Host: api.pushingbox.com");
      client.println();
    }
    while (client.available()) {
      client.read();
    }
    if (!client.connected()) {
      client.stop();
      while (true);
    }
    delay(1000);
    digitalWrite(buzzer, LOW);
    lcd.clear();
    counter = 0;
    harga = 0;
    lcd.setCursor(0, 0);
    lcd.print("Jumlah:");
    lcd.print(counter);
    lcd.setCursor(0, 1);
    lcd.print("Harga :");
    lcd.print(harga);
    pushreset = true;
  }
  if (resetValue == HIGH && pushreset == true) {
    pushreset = false;
  }
}
